SystemOrganization addCategory: #'Iliad-More-Examples'!

ILCometEvent subclass: #ILCometCounterChangedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Examples'!

ILApplication subclass: #ILCometCounterApplication
	instanceVariableNames: 'counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Examples'!

!ILCometCounterApplication class methodsFor: 'as yet unclassified' stamp: 'sa 4/16/2010 17:56'!
path
	^'examples/comet'! !

!ILCometCounterApplication methodsFor: 'controllers' stamp: 'sa 4/16/2010 17:59'!
index
	^[:e |
		e 
			build: self cometConnection;
			build: counter]! !

!ILCometCounterApplication methodsFor: 'initialization' stamp: 'sa 4/16/2010 17:59'!
initialize
	super initialize.
	counter := ILCometCounter new! !

ILApplication subclass: #ILCounterApplication
	instanceVariableNames: 'counters'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Examples'!

!ILCounterApplication class methodsFor: 'accessing' stamp: 'np 4/13/2009 14:01'!
path
	^'examples/counters'! !

!ILCounterApplication methodsFor: 'controllers' stamp: 'np 10/1/2009 00:04'!
counter
	^[:e |
		e a
			text: 'Switch to the multi counter example';
			linkToLocal: 'multicounter'.
		e build: self counters first]! !

!ILCounterApplication methodsFor: 'accessing' stamp: 'np 3/4/2009 15:32'!
counters
	^counters ifNil: [counters := {ILCounter new. ILCounter new. ILCounter new. ILCounter new}]! !

!ILCounterApplication methodsFor: 'controllers' stamp: 'np 3/4/2009 15:32'!
index
	^self counter! !

!ILCounterApplication methodsFor: 'controllers' stamp: 'np 10/1/2009 00:05'!
multicounter
	^[:e | 
		e a
			text: 'Switch to the simple counter example';
			linkToLocal: 'counter'.
		self counters do: [:each |
			e build: each]]! !

ILApplication subclass: #ILTodoListApplication
	instanceVariableNames: 'todoListGridWidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Examples'!

!ILTodoListApplication class methodsFor: 'accessing' stamp: 'np 4/13/2009 14:01'!
path
	^'examples/todo'! !

!ILTodoListApplication methodsFor: 'building' stamp: 'np 10/1/2009 00:12'!
actionLinksContents
	^[:e || div |
		div := e div class: 'selection'; yourself.
		div a
			action: [self selectPending]
			hash: 'pending';
			text: 'pending'.
		div space.
		div a
			action: [self selectCompleted]
			hash: 'completed';
			text: 'completed'.
		e br]! !

!ILTodoListApplication methodsFor: 'controllers' stamp: 'np 10/1/2009 12:37'!
index
	self updateFromHash.
	
	^self mainContents! !

!ILTodoListApplication methodsFor: 'initialization' stamp: 'np 7/13/2009 14:41'!
initialize
	super initialize.
	self model: ILTodoListItemRepository default! !

!ILTodoListApplication methodsFor: 'building' stamp: 'StevenCostiou 1/30/2010 18:55'!
mainContents
	^[:e | 
		e div
			class: 'wrapper';
			build: [:div |
				div h1: 'Todo List'.
				div build: self actionLinksContents.
				div build: self todoListGridWidget]]! !

!ILTodoListApplication methodsFor: 'accessing' stamp: 'StevenCostiou 1/24/2010 21:31'!
selectCompleted
	self todoListGridWidget selectBlock: [:item | item completed].
	self todoListGridWidget markDirty! !

!ILTodoListApplication methodsFor: 'accessing' stamp: 'StevenCostiou 1/24/2010 21:32'!
selectPending
	self todoListGridWidget selectBlock: [:item | item completed not].
	self todoListGridWidget markDirty! !

!ILTodoListApplication methodsFor: 'accessing' stamp: 'np 8/20/2009 15:33'!
todoListGridWidget
	^todoListGridWidget ifNil: [todoListGridWidget := ILTodoListGridWidget new]! !

!ILTodoListApplication methodsFor: 'building' stamp: 'np 8/20/2009 15:28'!
updateFromHash
	| path |
	path := self hashRoute next.
	path = 'pending' ifTrue: [self selectPending].
	path = 'completed' ifTrue: [self selectCompleted]! !

!ILTodoListApplication methodsFor: 'building' stamp: 'np 10/31/2009 18:13'!
updatePage: aPage
	super updatePage: aPage.
	aPage head stylesheet href: '/stylesheets/iliad.css'! !

Object subclass: #ILTodoListItem
	instanceVariableNames: 'deadline title body completed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Examples'!

!ILTodoListItem methodsFor: 'accessing' stamp: 'np 11/17/2009 23:25'!
body
	^body ifNil: ['']! !

!ILTodoListItem methodsFor: 'accessing' stamp: 'np 11/17/2009 23:25'!
body: aString
	body := aString! !

!ILTodoListItem methodsFor: 'accessing' stamp: 'np 4/11/2009 17:54'!
completed
	^completed ifNil: [false]! !

!ILTodoListItem methodsFor: 'accessing' stamp: 'np 4/11/2009 17:55'!
completed: aBoolean
	completed := aBoolean! !

!ILTodoListItem methodsFor: 'accessing' stamp: 'np 4/11/2009 19:15'!
deadline
	^deadline ifNil: [deadline := Date tomorrow]! !

!ILTodoListItem methodsFor: 'accessing' stamp: 'np 4/11/2009 19:15'!
deadline: aDeadline
	deadline := aDeadline! !

!ILTodoListItem methodsFor: 'accessing' stamp: 'np 4/12/2009 15:34'!
title
	^title ifNil: ['']! !

!ILTodoListItem methodsFor: 'accessing' stamp: 'np 4/11/2009 17:53'!
title: aString
	title := aString! !

Object subclass: #ILTodoListItemRepository
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Examples'!

ILTodoListItemRepository class
	instanceVariableNames: 'default'!

ILTodoListItemRepository class
	instanceVariableNames: 'default'!

!ILTodoListItemRepository class methodsFor: 'as yet unclassified' stamp: 'np 4/12/2009 20:47'!
default
	^default ifNil: [default := self new]! !

!ILTodoListItemRepository methodsFor: 'message list' stamp: 'np 4/12/2009 20:48'!
addItem: anItem 
	self items add: anItem! !

!ILTodoListItemRepository methodsFor: 'accessing' stamp: 'sa 2/18/2010 15:29'!
body
	^body ifNil: ['']! !

!ILTodoListItemRepository methodsFor: 'accessing' stamp: 'np 4/12/2009 20:49'!
items
	^items ifNil: [items := OrderedCollection new]! !

!ILTodoListItemRepository methodsFor: 'actions' stamp: 'np 4/12/2009 20:48'!
removeItem: anItem
	self items remove: anItem! !

ILWidget subclass: #ILCometCounter
	instanceVariableNames: 'counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Examples'!

!ILCometCounter methodsFor: 'as yet unclassified' stamp: 'sa 4/16/2010 18:14'!
contents
	^[:e |
		e h1: counter count printString.
		e a action: [self increase]; text: '++'.
		e a action: [self decrease]; text: '--'] ! !

!ILCometCounter methodsFor: 'as yet unclassified' stamp: 'sa 4/17/2010 17:52'!
decrease
	counter decrease.
	self markDirty.
	self triggerCometEvent: ILCometCounterChangedEvent new! !

!ILCometCounter methodsFor: 'as yet unclassified' stamp: 'sa 4/17/2010 17:52'!
increase
	counter increase.
	self markDirty.
	self triggerCometEvent: ILCometCounterChangedEvent new! !

!ILCometCounter methodsFor: 'as yet unclassified' stamp: 'sa 4/17/2010 17:51'!
initialize
	super initialize.
	counter := ILCometCounterModel instance.
	self pushOnCometEvent: ILCometCounterChangedEvent! !

ILWidget subclass: #ILCometCounterModel
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Examples'!

ILCometCounterModel class
	instanceVariableNames: 'instance'!

ILCometCounterModel class
	instanceVariableNames: 'instance'!

!ILCometCounterModel class methodsFor: 'as yet unclassified' stamp: 'sa 4/16/2010 18:03'!
instance
	instance ifNil: [instance := self new].
	^instance
	! !

!ILCometCounterModel methodsFor: 'as yet unclassified' stamp: 'sa 4/16/2010 18:04'!
count
	^count! !

!ILCometCounterModel methodsFor: 'as yet unclassified' stamp: 'sa 4/16/2010 18:05'!
decrease
	count := count - 1! !

!ILCometCounterModel methodsFor: 'as yet unclassified' stamp: 'sa 4/16/2010 18:05'!
increase
	count := count + 1! !

!ILCometCounterModel methodsFor: 'as yet unclassified' stamp: 'sa 4/16/2010 18:04'!
initialize
	super initialize.
	count := 0! !

ILWidget subclass: #ILCounter
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Examples'!

!ILCounter methodsFor: 'building' stamp: 'np 4/5/2010 17:40'!
contents
	^[:e |
		e h1: count greaseString.
		e a action: [self increase]; text: '++'.
		e space.
		e a action: [self decrease]; text: '--']! !

!ILCounter methodsFor: 'actions' stamp: 'np 4/11/2009 13:17'!
decrease
	count := count - 1.
	self markDirty! !

!ILCounter methodsFor: 'actions' stamp: 'np 4/11/2009 13:18'!
increase
	count := count + 1.
	self markDirty! !

!ILCounter methodsFor: 'initialization' stamp: 'np 10/27/2008 22:47'!
initialize
	super initialize.
	count := 0! !

!ILCounter methodsFor: 'building' stamp: 'np 10/31/2009 15:37'!
styles 
	^#('/stylesheets/iliad.css')! !

ILWidget subclass: #ILTodoListGridWidget
	instanceVariableNames: 'selectBlock dataGrid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Iliad-More-Examples'!

!ILTodoListGridWidget methodsFor: 'actions' stamp: 'np 1/4/2010 18:11'!
addNewItem
	| newItem |
	newItem := ILTodoListItem new.
	self 
		lightbox: ((self formulaForItem: newItem)
			addMessage: [:e | e h2: 'Add item'];
			yourself)
		onAnswer: [:item | item ifNotNil: [self application model addItem: item]]
		! !

!ILTodoListGridWidget methodsFor: 'building' stamp: 'StevenCostiou 1/24/2010 21:35'!
contents
	^[:e |
		self updateDataGridItems.
		e build: self dataGrid.
		e div a
			action: [self addNewItem];
			text: 'new']! !

!ILTodoListGridWidget methodsFor: 'accessing' stamp: 'np 4/5/2010 17:42'!
dataGrid
	^dataGrid ifNil: [
		dataGrid := (ILPagedDataGrid new
		items: (self items asSortedCollection: [:a :b | a deadline < b deadline]);
		columnNames: #('' 'Title' 'Body' 'Deadline' '' '');
		column: 1 buildContents:[:e :item | e form checkbox 
			checked: item completed;
			beSubmitOnClick;
			action:[:val | self setItem: item completed: val]];
		column: 2 buildContents:[:e :item | e text: item title];
		column: 3 buildContents:[:e :item | e text: item body];
		column: 4 buildContents:[:e :item | e text: item deadline greaseString];
		column: 5 buildContents:[:e :item | e a text: 'Edit'; action: [self editItem: item]];
		column: 6 buildContents:[:e :item | e a text: 'Remove'; action: [self removeItem: item]];
		rowsPerPage: 3;
		yourself)]! !

!ILTodoListGridWidget methodsFor: 'actions' stamp: 'np 1/4/2010 18:12'!
editItem: anItem
	self 
		lightbox: ((self formulaForItem: anItem)
			addMessage: [:e | e h2: 'Edit item ', anItem title];
			yourself)
		! !

!ILTodoListGridWidget methodsFor: 'accessing' stamp: 'np 1/4/2010 18:09'!
formulaForItem: anItem
	| formula |
	formula := ILFormula on: anItem.
	(formula dateInputOn: #deadline)
		label: 'Deadline'.
	(formula inputOn: #title)
		labelContents: [:e | e span class: 'required'; text: 'Title'];
		addCondition: [:val | val notNil and: [val notEmpty]]
		labelled: [:val | 'This field is required'].
	(formula textareaOn: #body)
		size: 30@10;
		labelContents: [:e | e span class: 'required'; text: 'Body'];
		addCondition: [:val | val notNil and: [val notEmpty]]
		labelled: [:val | 'This field is required'].
	(formula checkboxOn: #completed)
		label: 'Completed'.
	^formula! !

!ILTodoListGridWidget methodsFor: 'accessing' stamp: 'np 4/12/2009 20:49'!
items
	^self application model items select: self selectBlock! !

!ILTodoListGridWidget methodsFor: 'actions' stamp: 'np 4/12/2009 20:50'!
removeItem: anItem
	self application model removeItem: anItem.
	self markDirty! !

!ILTodoListGridWidget methodsFor: 'accessing' stamp: 'np 8/20/2009 15:35'!
selectBlock
	^selectBlock ifNil: [selectBlock := [:each | each completed not]]! !

!ILTodoListGridWidget methodsFor: 'accessing' stamp: 'np 4/12/2009 16:27'!
selectBlock: aBlock
	selectBlock := aBlock! !

!ILTodoListGridWidget methodsFor: 'actions' stamp: 'StevenCostiou 1/24/2010 21:34'!
setItem: anItem completed: aBoolean
	anItem completed: aBoolean.
	self updateDataGridItems! !

!ILTodoListGridWidget methodsFor: 'building' stamp: 'np 11/17/2009 23:26'!
tableHeadContents
	^[:e || head |
		head := e thead.
		head td text: ''.
		head td text: 'Title'.
		head td text: 'Body'.
		head td text: 'Deadline']! !

!ILTodoListGridWidget methodsFor: 'updating' stamp: 'StevenCostiou 1/24/2010 21:35'!
updateDataGridItems 
	self dataGrid items:
		(self items asSortedCollection: [:a :b| a deadline < b deadline])! !
